// cTst.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>

#include "can2ku.h"
int main(int argc, char* argv[])
{

	CPCIDrv cio = 0;
		
	if( !cio.Started )
		return 0;

	printf( "driver online\n" );

	UCHAR NodeID = 0x15;

	cio.SetBusParam( 0, 0, 0x1c, 0, 0, 0, 0, 0xFF, 0xFF, 0xFF, 0xFF );

	cio.SetBusParam( 1, 0,  0x1c, 

							0xF0, 
							(NodeID / 0x10) & 0x3, 
							( NodeID & 0x3F ) | 0x80, 
							NodeID & 0xF, 

							0x7, 0xFC, 0x0, 0xF0 );

	printf( "bus param set\n" );


	UCHAR MsgBfr[8];


	// I have connected channel 0 to channel 1
	// try sending on ch0 and rcv on ch1

	// Empty receive queues
	cio.ResetMsgQue();

	printf( "msg que reset\n" );

	DWORD mStart = GetTickCount();

	ULONG Ident;
	UCHAR MsgSize;
	ULONG Chn;

	for( int Cnt = 0; Cnt < 2000; Cnt++ )
	{

		MsgBfr[0] = 0x15;
		MsgBfr[7] = 0xAA;

		// Send it now
		cio.SendMsg( 0, 0x781, MsgBfr, 8 );
		//printf( "Msg Sent\n" );

		Ident	= 0;
		Chn		= 0;
		ZeroMemory( MsgBfr, 8 );

		cio.WaitForPacket( 100 );	
		//printf( "wait for packet over\n" );

		if( cio.GetMsg( Chn, Ident, MsgBfr, MsgSize ) )
		{
			//printf( "Got new pkt\n" );
			//ASSERT(Ident == 0x120);
			//ASSERT(MsgSize == 8);
			//ASSERT(Chn == 1);
			//ASSERT(MsgBfr[0] == 0x15 );
			//ASSERT(MsgBfr[7] == 0xAA );
		}
		else
		{
			printf( "No mesasge detected\n" );
			break;
		}
	}

	printf( "%d Msg sent/received in %d mSec\n", Cnt, GetTickCount() - mStart );
	getchar();

	return 0;
}
