// cTst.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include "CANDrvBase.h"
#include "PCINet.h"

UINT gSendCntr = 1;
UINT SendsC = 1;

int main(int argc, char* argv[])
{

	CPCINet CAN_Channel(0); //open channel 0
		
	if( !CAN_Channel.mStarted )
		return 0;

	printf( "driver online\n" );

	// Set Bus parameters for 125kbps. accept all messages
	CAN_Channel.SetBusParam( 3, 0x1c, 0, 0, 0, 0, 0xFF, 0xFF, 0xFF, 0xFF );
	
	//CAN_Channel.SetBusParam( 3, 0x1c, 0, 0x7FF, 0x780, 0x7FF );

	printf( "bus param set\n" );

	// Empty receive queues
	CAN_Channel.ResetMsgQue();

	printf( "msg que reset\n" );

	ULONG Ident;
	UCHAR MsgSize;

	UCHAR mDat[10];

	mDat[0] = 10;
	mDat[1] = 60;
	mDat[2] = 11;

	// SendMsg sends one message to the bus.  If the CAN controller chip is not ready, 
	// the fucntion returns false.  you must retry in that case. A counter may be added to 
	// terminate the loop in case the error is permanent.
	while( !CAN_Channel.SendMsg( 0x780 | 0, mDat, 3 ) )
		Sleep(1);

	while( !kbhit() )
	{
		// Empty the driver Receive Queue for this channel.
		while( CAN_Channel.GetMsg( Ident, mDat, MsgSize ) )
		{
			static int Cntr = 0;
			printf( "rcv:%05d, Snd: %05d,- %d %03d %d %d %X\n",
				Cntr++, SendsC, mDat[0],mDat[1],mDat[2],mDat[3], Ident );
		}

		if( gSendCntr % 200 == 0 )
		{
			mDat[0] = 10;
			mDat[1] = 60;
			mDat[2] = 11;

			CAN_Channel.SendMsg( 0x780 | 0, mDat, 3 );
			SendsC++;
		}

		gSendCntr++;

		Sleep( 1 );
	} 


	getchar();

	return 0;
}





